//
//  DeviceViewController.m
//  STEEForiOSApp
//
//

#import "DeviceViewController.h"
#import <DXRisk/DXRiskManager.h>
#import <AppTrackingTransparency/AppTrackingTransparency.h>
#import <AdSupport/ASIdentifierManager.h>
#import "MD5Utils.h"
#import "UnityUtil.h"


#define DEFAULT_URL @"填入 url"
#define DEFAULT_APPID @"填入 appid"
#define DEFAULT_APPSEC @"填入 sec"


@interface DeviceViewController ()

@end

@implementation DeviceViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    _tokenSwitch.on = NO;
    
    self.locationManager = [[CLLocationManager alloc] init];
    [self.locationManager requestWhenInUseAuthorization];

    if (@available(iOS 14, *)) {
        [ATTrackingManager requestTrackingAuthorizationWithCompletionHandler:^(ATTrackingManagerAuthorizationStatus status) {
            if (status == ATTrackingManagerAuthorizationStatusAuthorized) {
                NSString *idfa = [[ASIdentifierManager sharedManager].advertisingIdentifier UUIDString];
            } else {
                NSLog(@"请在设置-隐私-跟踪中允许App请求跟踪");
            }
        }];
    } else {
        if ([[ASIdentifierManager sharedManager] isAdvertisingTrackingEnabled]) {
            NSString *idfa = [[ASIdentifierManager sharedManager].advertisingIdentifier UUIDString];
        } else {
            NSLog(@"请在设置-隐私-广告中打开广告跟踪功能");
        }
    }
    
    //态势感知注册
    NSNotificationCenter *no = [NSNotificationCenter defaultCenter];
    [no addObserver:self selector:@selector(pop:) name:@"DXRISKSITUATION" object:nil];

}
//态势感知主动掉起
- (IBAction)UpSituation:(id)sender {
    [DXRiskManager updateSituation];
}

- (void)pop:(NSNotification *)obj
{
    NSLog(@"态势感知返回值-%@",obj.object);
}
-(void)dealloc
{
    [NSNotificationCenter removeObserver:self forKeyPath:@"DXRISKSITUATION"];
}
- (IBAction)clickGetToken:(id)sender {

    _showTextView.text = @"";

    NSString *appid = [_appIdTextView.text isEqualToString:@""] ? DEFAULT_APPID : _appIdTextView.text;
    NSString *appSec = [_appSecTextView.text isEqualToString:@""] ? DEFAULT_APPSEC : _appSecTextView.text;
    NSString *url = ([_urlTextView.text isEqualToString:@""] || [_urlTextView.text isEqualToString:@"http://"]) ? DEFAULT_URL:_urlTextView.text;
    
    //SDK初始化,仅做展示,具体调用位置见开发文档
    BOOL isSuccess = [DXRiskManager setup];
    NSLog(@"初始化是否成功:%@",isSuccess?@"是":@"否");
    NSString *mTokenUrl = url;
//    NSString *mTokenUrl = [NSString stringWithFormat:@"%@%@", url, @"/udid/m1"];
    NSString *mEngineUrl = [NSString stringWithFormat:@"%@%@", url, @"/udid/api/getDeviceInfo"];
    NSString *sTokenUrl = [NSString stringWithFormat:@"%@%@", url, @"/udid/sa-m"];
    //SDK上报配置项
    NSMutableDictionary *Params = [NSMutableDictionary new];
    //此项为预留项,可填可不填
    Params[DXRiskManagerKeyUserId] = @"123456";
    //必填项目
    Params[DXRiskManagerKeyURL] = mTokenUrl;
    Params[DXRiskManagerSituationUrl] = sTokenUrl;
    //缓存 token 开关
    Params[@"PRIVATE_CLEAR_TOKEN"] = @"false";
    //SDK场景上报
    [DXRiskManager beginScene:@"login"];
    NSString *requestInfo = [NSString stringWithFormat:@"%@%@" , @"----请求信息----" , @"\r\n" ];
    requestInfo = [requestInfo stringByAppendingFormat:@"%@%@%@" ,@"appId:" , appid , @"\r\n"];
    requestInfo = [requestInfo stringByAppendingFormat:@"%@%@%@" ,@"appSec:" , appSec , @"\r\n"];
    requestInfo = [requestInfo stringByAppendingFormat:@"%@%@%@" ,@"risk url:" , mTokenUrl , @"\r\n"];
    requestInfo = [requestInfo stringByAppendingFormat:@"%@%@%@" ,@"info url:" , mEngineUrl , @"\r\n\n"];

    _showTextView.text = requestInfo;
    double nowtime = [self currentTime];
    
    
    /**
     *
     * SDK token 获取
     * appid
     * 配置项
     * 业务 sid (如没有置为空)
     */
    NSString *token = [DXRiskManager getToken:appid extendsParams: Params WithSid:@""];
    
    
    NSString *response = [NSString stringWithFormat:@"%@%@" , @"----请求结果----" , @"\r\n" ];
    response = [response stringByAppendingFormat:@"%@%@%@" ,@"token:" , token, @"\r\n"];

    //此项为 Demo 专用接口,用来展示设备指纹以及风险等采集
    NSString *reponseDevice = [self getDeviceInfo:token andAppId:appid andAppSecret:appSec andRequestUrl:mEngineUrl];

    
    //由于网络不佳或者配置项填错等其它原因,导致SDK 内部与服务端交互失败,token 将会降级
    /*正常 token示例:
    613ec655w1Vj59zpD66H4uycXnu5U3zu17TEmrO3
     */
    /*降级 token示例:
     hH_HXxlYnmQGpt1XAPhJhHkRgRI0pofYmAMopfw3NpX0n9eTbhvpATVIN3LvvOOLL-IlJ5P11nP9OXkt3uB-lk8yI9uiqp9sjya5vM6pKdAHj4NgbEfRrPdoEh5hi4xENUglrqsELOF5eksMzUgG2D661UQmDTiGop4AFkG0ArBBsNnPOpmnw-THH49QrAGAftU99Rb-s3HnKqrh-as5gNovJ0Dto_FqdNf6Q8CnXdhX57yT4W9toT3QwFIo9eN3dP9M6ewMI9yopLCx9fdPYqVa-uY8w6aj-d5PExoZu4QZ_55s03cx6kMDTthqoE_zuQoOwiUCBwW-ERpotoZXrEo8P4rTIuS8pWkpL0ulq7UOg1aW-P1jtQK7D_Etxegh5FZiW9gBB1T693TXzv-VCV5I-jolRlDrvSyamsPL1nObMM5l0Vum7fci2H3N-ptKSPCN9_rCkdOPrpTVkb4kgzM85ZulMyYrIi-mynAP64VMrvA5bHQ-1nIZmpn_kAeClEsa2sNFR-y3Q9-oJzNlb7AMOh2Yx5Liqxgt0eFXXjZCLVns1D1NURjOjiT_wLfbsgJ6MMYtV1_zyCLAlHQc3IJMBU9CQde5h0UdZT1t44FdMQ49v7g2VylmfiqX8jrmxOPKOZRl2MxRV9sNKfnmSAJhehYdFCMgYvoM74_PMZun6kEWD5cmt8TRZ8Z8hwfVFDaeHGnO7hZwzlIHaijlw18g1ZzkHYUtVYYv2PNcx2CIfdG28ELJ1KQciC8RQT0BArOKtCD9vHo8aRTO57GeurvNuu34BZpfKx6_l00Mtqp3pwtGFz95I7WYZFiqC-x4sDPJlI31Elq8lVS1Axg4a0tWyINM-rnIiz44FxaQ5-xHfZqgGRYjii9T0SjjB_Rz9ZD7LgzX0Ce8TcI9kz006KMgPHen4F_I6zOP-BcUQdeU5aX81AOgp_u2sOtOfwP3RZvTTtcIGuq4UN2zoqY-UW0edWJeiK7oZOclWx6SD2vqsjxUusu1L9RzQMibOlA6jM6BsR3UNrxMq9KqLBBN4pIc0ttZ3pAyZJWDIXVvM1eIlE6E1tEp-yu-al2KA6RGQYTxc_DoSB1f2c1bdUEqQ6mAMKnun2A9Grzy3ZGCkMtFVWTYw-HOcSx59eqrjBZeX_A_Uf63J_a8m9kIdMdPiumJ0qvFC0ZPps4tm1EZjv8UjNIEl-X_xsgK-LHghHiRdsZwq0wJxUCO5CPePUjYgYv_tJkrqFBwurkPQkOAJrUWAZ4AFHwsBxT_7dn-QIjv1ioT_UbIZtp_It2z5_bjRBmlrdTQ1S4WTRdg-ny64V71y7h-tmo6DNXt-VMrK6XOGjBXsO8TSVsuSeiUILIrceYvkiR1M_Mv23-aEZBNY-gtDdCYmR6fgbt79FUsqpQMyq_wWTWQjZZ3PwS8bjSG3aFpvRVihtgzX99MdhC5zCFBBbcTaeHl5aVlOhGDjtoBSJsx4b-MR61DHksuCBO2XBytVvbCze-serAtP0FFcFKTqCAF!51de47723a4b64b4e3100b864429c5a61!2d34e7675da49f7e2bc23f042b0a54c4!risk_situation_sdk.c5b2e7cf
     */

    response = [response stringByAppendingFormat:@"%@%@"  , reponseDevice , @"\r\n\n"];

    response = [response stringByAppendingFormat:@"%@%@"   , @"----性能消耗信息----" ,@"\r\n"];

    NSString *memuse = [NSString stringWithFormat:@"%.1fKB\r",[UnityUtil memoryUsage]];
    NSString *cpuuse = [NSString stringWithFormat:@"%.2f%%\r",[UnityUtil cpuUsage]];
    NSString *memshow = [NSString stringWithFormat:@"%@%@\n",@"内存使用:",memuse];
    NSString *cpushow = [NSString stringWithFormat:@"%@%@\n",@"CPU使用:",cpuuse];
    NSString *showtime = [NSString stringWithFormat:@"%@%.0f ms\n",@"采集耗时:",[self currentTime]-nowtime];

    NSString *showText = [NSString stringWithFormat:@"%@%@%@",memshow,cpushow,showtime];
    response = [response stringByAppendingFormat:@"%@"   , showText];
    _showTextView.text = [NSString stringWithFormat:@"%@%@" , requestInfo , response ];


}

- (void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event{

    [self.view endEditing:YES];
}

- (NSString *)jsonStringWithDict:(NSDictionary *)dict {
    NSError *error;
    NSData *jsonData = [NSJSONSerialization dataWithJSONObject:dict options:NSJSONWritingPrettyPrinted error:&error];
    NSString *jsonString;
    if (!jsonData) {

    }else{
        jsonString = [[NSString alloc]initWithData:jsonData encoding:NSUTF8StringEncoding];
    }
    return jsonString;
}


- (NSDictionary *)dictionaryWithJsonString:(NSString *)jsonString
{
    if (jsonString == nil) {
        return nil;
    }

    NSData *jsonData = [jsonString dataUsingEncoding:NSUTF8StringEncoding];
    NSError *err;
    NSDictionary *dic = [NSJSONSerialization JSONObjectWithData:jsonData
                                                        options:NSJSONReadingMutableContainers
                                                          error:&err];
    if(err)
    {
        return nil;
    }
    return dic;
}


//获取当前时间戳
-(double)currentTime{
    NSDate* date = [NSDate dateWithTimeIntervalSinceNow:0];
    NSTimeInterval time=[date timeIntervalSince1970]*1000;
    return time;
}


- (NSString*) getDeviceInfo:(NSString*) token andAppId:(NSString*) AppID andAppSecret:(NSString*) AppSecret andRequestUrl:(NSString*) requestUrl {
    NSString* mdStr = [MD5Utils getmd5WithString:[NSString stringWithFormat:@"%@%@%@", AppSecret, token , AppSecret]];
    NSString* url = [requestUrl stringByAppendingString:@"?appId="];
    url = [url stringByAppendingString:AppID];
    url = [url stringByAppendingString:@"&token="];
    url = [url stringByAppendingString: [NSString stringWithString:[token stringByReplacingPercentEscapesUsingEncoding:NSUTF8StringEncoding]]];
    url = [url stringByAppendingString:@"&sign="];
    url = [url stringByAppendingString:mdStr];

    return [self httpGet:url];
}


- (NSString*) httpGet:(NSString*) url{
    NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:[NSURL URLWithString:url]];
    request.HTTPMethod = @"get";
    [request setValue:@"*/*" forHTTPHeaderField:@"Accept"];
    [request setValue:@"STEE-SDK" forHTTPHeaderField:@"User-Agent"];
    [request setValue:@"keep-Alive" forHTTPHeaderField:@"connection"];

    NSError *error = nil;
    NSURLResponse *response = nil;
    //发送同步请求(sendSynchronousRequest)
    NSData *data = [NSURLConnection sendSynchronousRequest:request returningResponse:&response error:&error];

    if (!error) {
        //打印的服务端返回的信息以及错误信息
//        NSLog(@"%@",[[NSString alloc]initWithData:data encoding:NSUTF8StringEncoding]);
//        NSLog(@"request-reponse--%@",error);
        return [[NSString alloc]initWithData:data encoding:NSUTF8StringEncoding];

    }else {
//        NSLog(@"request-reponse--%@",error);
        return [[NSString alloc]initWithData:data encoding:NSUTF8StringEncoding];
    }
}



@end
